import { Component, h, Prop, State } from '@stencil/core';
import apiFetch from '../../../../functions/fetch';
import { __ } from '@wordpress/i18n';
import { addQueryArgs } from '@wordpress/url';
export class ScDownloadsList {
  constructor() {
    this.renderFileExt = download => {
      var _a, _b, _c, _d, _e, _f, _g, _h, _j;
      if ((_a = download === null || download === void 0 ? void 0 : download.media) === null || _a === void 0 ? void 0 : _a.filename) {
        return (_e = (_d = (_c = (_b = download.media.filename).split) === null || _c === void 0 ? void 0 : _c.call(_b, '.')) === null || _d === void 0 ? void 0 : _d.pop) === null || _e === void 0 ? void 0 : _e.call(_d);
      }
      if (download === null || download === void 0 ? void 0 : download.url) {
        try {
          const url = new URL(download.url);
          if (url.pathname.includes('.')) {
            return (_j = (_h = (_g = (_f = url.pathname).split) === null || _g === void 0 ? void 0 : _g.call(_f, '.')) === null || _h === void 0 ? void 0 : _h.pop) === null || _j === void 0 ? void 0 : _j.call(_h);
          }
        }
        catch (err) {
          console.error(err);
        }
      }
      return h("sc-icon", { name: "file" });
    };
  }
  async downloadItem(download) {
    var _a, _b;
    if (download === null || download === void 0 ? void 0 : download.url) {
      this.downloadFile(download.url, (_a = download === null || download === void 0 ? void 0 : download.name) !== null && _a !== void 0 ? _a : 'file');
      return;
    }
    const mediaId = (_b = download === null || download === void 0 ? void 0 : download.media) === null || _b === void 0 ? void 0 : _b.id;
    if (!mediaId)
      return;
    try {
      this.busy = mediaId;
      const media = (await apiFetch({
        path: addQueryArgs(`surecart/v1/customers/${this.customerId}/expose/${mediaId}`, {
          expose_for: 60,
        }),
      }));
      if (!(media === null || media === void 0 ? void 0 : media.url)) {
        throw {
          message: __('Could not download the file.', 'surecart'),
        };
      }
      this.downloadFile(media === null || media === void 0 ? void 0 : media.url, media.filename);
    }
    catch (e) {
      console.error(e);
      this.error = (e === null || e === void 0 ? void 0 : e.message) || __('Something went wrong', 'surecart');
    }
    finally {
      this.busy = null;
    }
  }
  downloadFile(path, filename) {
    // Create a new link
    const anchor = document.createElement('a');
    anchor.href = path;
    anchor.download = filename;
    // Append to the DOM
    document.body.appendChild(anchor);
    // Trigger `click` event
    anchor.click();
    // To make this work on Firefox we need to wait
    // a little while before removing it.
    setTimeout(() => {
      document.body.removeChild(anchor);
    }, 0);
  }
  render() {
    const downloads = this.downloads || [];
    return (h("sc-dashboard-module", { class: "purchase", part: "base", heading: __('Downloads', 'surecart') },
      h("span", { slot: "heading" },
        h("slot", { name: "heading" }, this.heading || __('Downloads', 'surecart'))),
      h("sc-card", { "no-padding": true },
        h("sc-stacked-list", null, downloads.map(download => {
          var _a, _b, _c, _d;
          const media = download === null || download === void 0 ? void 0 : download.media;
          return (h("sc-stacked-list-row", { style: { '--columns': '1' } },
            h("sc-flex", { class: "single-download", justifyContent: "flex-start", alignItems: "center" },
              h("div", { class: "single-download__preview" }, this.renderFileExt(download)),
              h("div", null,
                h("div", null,
                  h("strong", null, (_b = (_a = media === null || media === void 0 ? void 0 : media.filename) !== null && _a !== void 0 ? _a : download === null || download === void 0 ? void 0 : download.name) !== null && _b !== void 0 ? _b : '')),
                h("sc-flex", { justifyContent: "flex-start", alignItems: "center", style: { gap: '0.5em' } },
                  (media === null || media === void 0 ? void 0 : media.byte_size) && h("sc-format-bytes", { value: media.byte_size }),
                  !!((_c = media === null || media === void 0 ? void 0 : media.release_json) === null || _c === void 0 ? void 0 : _c.version) && (h("sc-tag", { type: "primary", size: "small", style: {
                      '--sc-tag-primary-background-color': '#f3e8ff',
                      '--sc-tag-primary-color': '#6b21a8',
                    } },
                    "v", (_d = media === null || media === void 0 ? void 0 : media.release_json) === null || _d === void 0 ? void 0 :
                    _d.version))))),
            h("sc-button", { size: "small", slot: "suffix", onClick: () => this.downloadItem(download), busy: (media === null || media === void 0 ? void 0 : media.id) ? this.busy == (media === null || media === void 0 ? void 0 : media.id) : false, disabled: (media === null || media === void 0 ? void 0 : media.id) ? this.busy == (media === null || media === void 0 ? void 0 : media.id) : false }, __('Download', 'surecart'))));
        })))));
  }
  static get is() { return "sc-downloads-list"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["sc-downloads-list.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["sc-downloads-list.css"]
  }; }
  static get properties() { return {
    "downloads": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "Download[]",
        "resolved": "Download[]",
        "references": {
          "Download": {
            "location": "import",
            "path": "../../../../types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      }
    },
    "customerId": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "customer-id",
      "reflect": false
    },
    "heading": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "heading",
      "reflect": false
    }
  }; }
  static get states() { return {
    "busy": {},
    "error": {}
  }; }
}
